//+------------------------------------------------------------------+
//|                            Synthetic CoIntegration Indicator.mq4 |
//|                         Copyright  2008-2010, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008-2010, TradingSytemForex"
#property link "http://www.tradingsystemforex.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DeepSkyBlue
//#property indicator_color2 OrangeRed
//#property indicator_color3 OrangeRed

double Line[];
double Line2[];
double Line3[];
double prevtime;
double Range,AvgRange;

double LimeRmonow,LimeRmoprevious;
double GoldRmonow,GoldRmoprevious;

extern int N1=5;
extern int N2=25;

extern string Symbol1="EURUSD";
extern string Symbol2="USDCHF";
extern int Price=PRICE_CLOSE;   //posible: PRICE_CLOSE=0, PRICE_OPEN=1, PRICE_HIGH=2, PRICE_LOW=3;

extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;

extern int countbars=500;
/*
extern bool popupalert=false;
extern bool soundalert=false;
extern bool emailalert=false;
*/
//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int cntn1;
int cntn2;

datetime timex;

int init(){
//---- indicators

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Line);
   SetIndexDrawBegin(0,0.0);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(1,Line2);
   SetIndexDrawBegin(1,0.0);
   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,Line3);
   SetIndexDrawBegin(2,0.0);
   /*
   SetIndexStyle(1,DRAW_ARROW,EMPTY,2);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,CrossDown);*/
//----
   return(0);
}
  
//+------------------------------------------------------------------+
//| Deinitialization                                                 |
//+------------------------------------------------------------------+

int deinit(){
//---- 

//----
   return(0);
}

//+------------------------------------------------------------------+
//| Iteration                                                        |
//+------------------------------------------------------------------+

int start(){
   int limit,i,j,counter;
   int counted_bars=IndicatorCounted();
   double ir,irma,ira,irmaa;
   double xir,xirma,xira,xirmaa;
   
   if(counted_bars<0)return(-1);
   if(counted_bars>0)counted_bars--;
   
   limit=countbars;//Bars-counted_bars;
   
   if(timex==Time[0])return(0);
   for(j=0;j<=limit;j++){
      cntn1=0;
      cntn2=0;
      Print("J = "+DoubleToStr(j,0));
      for(i=j;i<=j+((1440*N1)/Period());i++){
         ir=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,0,i);
         irma=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,1,i);
         ira=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,0,i+1);
         irmaa=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,1,i+1);
         if((ir>irma && ira<irmaa) || (ir<irma && ira>irmaa))cntn1++;
      }
      Line2[j]=cntn1;
      for(i=j;i<=j+((1440*N2)/Period());i++){
         xir=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,0,i);
         xirma=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,1,i);
         xira=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,0,i+1);
         xirmaa=iCustom(NULL,0,"instruments_ratio",Symbol1,Symbol2,Price,BandsPeriod,BandsShift,BandsDeviations,1,i+1);
         if((xir>xirma && xira<xirmaa) || (xir<xirma && xira>xirmaa))cntn2++;
      }
      Line3[j]=cntn2;
      if(timex!=Time[0]){
         Comment(
         "\nC1 = "+DoubleToStr(cntn1,0),
         "\nC2 = "+DoubleToStr(cntn2,0));
         timex=Time[0];
      }
      Line[j]=(Line2[j]/Line3[j])*100;
   }
   return(0);
 }

